import { __extends } from "tslib";
import { ToolActionButtonDisplayType_$type } from "./ToolActionButtonDisplayType";
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionButton } from "./ToolActionButton";
import { getAllPropertyNames, toSpinal, ensureEnum, enumToString } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
var IgcToolActionButtonComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolActionButtonComponent, _super);
    function IgcToolActionButtonComponent() {
        return _super.call(this) || this;
    }
    IgcToolActionButtonComponent.prototype.createImplementation = function () {
        return new ToolActionButton();
    };
    Object.defineProperty(IgcToolActionButtonComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionButtonComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcToolActionButtonComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcToolActionButtonComponent, "observedAttributes", {
        get: function () {
            if (IgcToolActionButtonComponent._observedAttributesIgcToolActionButtonComponent == null) {
                var names = getAllPropertyNames(IgcToolActionButtonComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionButtonComponent._observedAttributesIgcToolActionButtonComponent = names;
            }
            return IgcToolActionButtonComponent._observedAttributesIgcToolActionButtonComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionButtonComponent.register = function () {
        if (!IgcToolActionButtonComponent._isElementRegistered) {
            IgcToolActionButtonComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcToolActionButtonComponent.htmlTagName, IgcToolActionButtonComponent);
        }
    };
    Object.defineProperty(IgcToolActionButtonComponent.prototype, "displayType", {
        /**
         * Gets or sets the display type for the button.
        */
        get: function () {
            return this.i.f7;
        },
        set: function (v) {
            this.i.f7 = ensureEnum(ToolActionButtonDisplayType_$type, v);
            this._a("displayType", enumToString(ToolActionButtonDisplayType_$type, this.i.f7));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionButtonComponent.prototype, "cornerRadius", {
        /**
         * Gets or sets the button corner radius.
        */
        get: function () {
            return this.i.gc;
        },
        set: function (v) {
            this.i.gc = +v;
            this._a("cornerRadius", this.i.gc);
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionButtonComponent._observedAttributesIgcToolActionButtonComponent = null;
    IgcToolActionButtonComponent.htmlTagName = "igc-tool-action-button";
    IgcToolActionButtonComponent._isElementRegistered = false;
    return IgcToolActionButtonComponent;
}(IgcToolActionComponent));
export { IgcToolActionButtonComponent };
