import { ToolActionType_$type } from "igniteui-webcomponents-core";
import { ToolActionEventDetail as ToolActionEventDetail_internal } from "./ToolActionEventDetail";
import { ensureEnum, ensureBool } from "igniteui-webcomponents-core";
var IgcToolActionEventDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgcToolActionEventDetail() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcToolActionEventDetail.prototype.createImplementation = function () {
        return new ToolActionEventDetail_internal();
    };
    Object.defineProperty(IgcToolActionEventDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionEventDetail.prototype.onImplementationCreated = function () {
    };
    IgcToolActionEventDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcToolActionEventDetail.prototype, "actionId", {
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "actionType", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureEnum(ToolActionType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "isModified", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "boolValue", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "numberValue", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "dateTimeValue", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "untypedValue", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionEventDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgcToolActionEventDetail;
}());
export { IgcToolActionEventDetail };
