import { __extends } from "tslib";
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionRadio } from "./ToolActionRadio";
import { getAllPropertyNames, toSpinal, ensureBool } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
var IgcToolActionRadioComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolActionRadioComponent, _super);
    function IgcToolActionRadioComponent() {
        return _super.call(this) || this;
    }
    IgcToolActionRadioComponent.prototype.createImplementation = function () {
        return new ToolActionRadio();
    };
    Object.defineProperty(IgcToolActionRadioComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionRadioComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcToolActionRadioComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcToolActionRadioComponent, "observedAttributes", {
        get: function () {
            if (IgcToolActionRadioComponent._observedAttributesIgcToolActionRadioComponent == null) {
                var names = getAllPropertyNames(IgcToolActionRadioComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionRadioComponent._observedAttributesIgcToolActionRadioComponent = names;
            }
            return IgcToolActionRadioComponent._observedAttributesIgcToolActionRadioComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionRadioComponent.register = function () {
        if (!IgcToolActionRadioComponent._isElementRegistered) {
            IgcToolActionRadioComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcToolActionRadioComponent.htmlTagName, IgcToolActionRadioComponent);
        }
    };
    Object.defineProperty(IgcToolActionRadioComponent.prototype, "channel", {
        /**
         * Gets or sets the channel this radio button belongs to.
        */
        get: function () {
            return this.i.gc;
        },
        set: function (v) {
            this.i.gc = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionRadioComponent.prototype, "isChecked", {
        /**
         * Gets or sets if the tool action is checked.
        */
        get: function () {
            return this.i.f9;
        },
        set: function (v) {
            this.i.f9 = ensureBool(v);
            this._a("isChecked", this.i.f9);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionRadioComponent.prototype, "isManual", {
        /**
         * Gets or sets if the checked state of the radio is handled manually by the user. The radio
         * well not become selected when clicked if this property is true.
        */
        get: function () {
            return this.i.ga;
        },
        set: function (v) {
            this.i.ga = ensureBool(v);
            this._a("isManual", this.i.ga);
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionRadioComponent.prototype.fromInfo = function (info) {
        this.i.ej(info);
    };
    IgcToolActionRadioComponent._observedAttributesIgcToolActionRadioComponent = null;
    IgcToolActionRadioComponent.htmlTagName = "igc-tool-action-radio";
    IgcToolActionRadioComponent._isElementRegistered = false;
    return IgcToolActionRadioComponent;
}(IgcToolActionComponent));
export { IgcToolActionRadioComponent };
