import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-webcomponents-core";
import { DomRenderer, DomWrapper } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { NativeUIAbsolutePanel } from "igniteui-webcomponents-core";
import { NativeUIGrid } from "igniteui-webcomponents-core";
import { IDataSource } from "igniteui-webcomponents-core";
import { IExternalListPanel } from "./IExternalListPanel";
import { IExecutionContext } from "igniteui-webcomponents-core";
import { Brush } from "igniteui-webcomponents-core";
import { ListPanelOrientation } from "./ListPanelOrientation";
import { ListPanelItemModel } from "./ListPanelItemModel";
import { ListPanelContentRefreshedEventArgs } from "./ListPanelContentRefreshedEventArgs";
import { ListPanelTemplateItemUpdatingEventArgs } from "./ListPanelTemplateItemUpdatingEventArgs";
import { ListPanelTemplateWidthRequestedEventArgs } from "./ListPanelTemplateWidthRequestedEventArgs";
import { ListPanelTemplateHeightRequestedEventArgs } from "./ListPanelTemplateHeightRequestedEventArgs";
import { IDataSourceUpdateNotifier } from "igniteui-webcomponents-core";
import { NativeUIContainer } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class ListPanelView extends Base {
    static $t: Type;
    private n;
    private m;
    constructor();
    p(): any;
    a: ListPanel;
    v(): void;
    i: DomRenderer;
    l: DomWrapper;
    e: RenderingContext;
    k: DomWrapper;
    t(a: DomRenderer): void;
    y(): void;
    x(): void;
    s(): void;
    z(): void;
    private b;
    private aa;
    private c;
    private _gridExternal;
    d(): FontInfo;
    u(): void;
    w(): void;
    r(a: number, b: number): void;
    g(): number;
    h(a: string): number;
    f: boolean;
    private j;
    q(a: any, b: (arg1: any) => void): void;
}
/**
 * @hidden
 */
export declare class ListPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    o: ListPanelView;
    u: NativeUIGrid;
    private y;
    private v;
    private get w();
    private h;
    by(a: NativeUIAbsolutePanel): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    private ba;
    cg(a: Size): void;
    get itemsSource(): any;
    set itemsSource(a: any);
    private a;
    get actualDataSource(): IDataSource;
    set actualDataSource(a: IDataSource);
    private ag;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private a2;
    get a9(): number;
    set a9(a: number);
    private ar;
    get av(): number;
    set av(a: number);
    private r;
    get s(): FontInfo;
    set s(a: FontInfo);
    t(): FontInfo;
    private x;
    get ah(): boolean;
    private bb;
    protected cd(a: string, b: any, c: any): void;
    private bp;
    private as;
    private aq;
    private ap;
    private ad;
    private z;
    private ac;
    protected ck(): void;
    private br;
    contentRefreshed: (sender: any, args: ListPanelContentRefreshedEventArgs) => void;
    private co;
    private bs;
    rowUpdating: (sender: any, args: ListPanelTemplateItemUpdatingEventArgs) => void;
    private bv;
    private bu;
    private q;
    itemWidthRequested: (sender: any, args: ListPanelTemplateWidthRequestedEventArgs) => void;
    itemHeightRequested: (sender: any, args: ListPanelTemplateHeightRequestedEventArgs) => void;
    private bo;
    private ay;
    private az;
    private bt;
    private g;
    private p;
    private cr;
    private ao;
    private cn;
    private a8;
    private a7;
    private al;
    private ak;
    private an;
    private am;
    ax(a: number): number;
    aw(a: number): number;
    private bn;
    bw(): void;
    cp(): void;
    private b3;
    private ae;
    private ab;
    private b2;
    bx(): void;
    cq(): void;
    a6(): number;
    a5(): number;
    private a0;
    private a1;
    private aj;
    b1(): void;
    private b0;
    private cl;
    private cm;
    cj(): void;
    private bz;
    private cb;
    private d;
    get externalListPanel(): IExternalListPanel;
    set externalListPanel(a: IExternalListPanel);
    protected ch(a: string, b: any, c: any): void;
    c: IExecutionContext;
    cs(): void;
    cz(): Size;
    ca(a: number, b: number): void;
    cf(a: number, b: any, c: any): void;
    b9(): void;
    cc(a: number, b: any): void;
    ce(a: number, b: any): void;
    b7(a: number, b: any, c: any): void;
    b4(): void;
    b5(a: number, b: any): void;
    b6(a: number, b: any): void;
    a3(a: any): number;
    a4(a: any[]): number;
    static cw: Brush;
    private ct;
    get cv(): Brush;
    set cv(a: Brush);
    static j: ListPanelOrientation;
    private i;
    get k(): ListPanelOrientation;
    set k(a: ListPanelOrientation);
    static af: boolean;
    private aa;
    get ai(): boolean;
    set ai(a: boolean);
    static cx: Brush;
    cu: Brush;
    get cy(): Brush;
    set cy(a: Brush);
    get au(): number;
    get at(): number;
}
/**
 * @hidden
 */
export declare class ListPanelDataSourceNotificationBridge extends Base implements IDataSourceUpdateNotifier {
    static $t: Type;
    private a;
    constructor(a: ListPanel);
    rangeActualized(a: number, b: number): void;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
}
/**
 * @hidden
 */
export declare class ListPanelLayoutPanel extends Base {
    static $t: Type;
    private a;
    constructor(a: NativeUIAbsolutePanel);
    e(a: Size): void;
    b(a: ListPanel, b: ListPanelItemModel): void;
    c(a: NativeUIContainer): void;
    d(a: ListPanelItemModel): void;
}
