import { Base, Type, INotifyPropertyChanged, EventArgs, PropertyChangedEventArgs } from "igniteui-webcomponents-core";
import { INativeUIElementFactory } from "igniteui-webcomponents-core";
import { NativeUIElementFactoryFlavor } from "igniteui-webcomponents-core";
import { NativeUIComponent } from "igniteui-webcomponents-core";
import { NativeUIComponentBuiltInType } from "igniteui-webcomponents-core";
import { DomRenderer, DomWrapper } from "igniteui-webcomponents-core";
import { XComponentBridge } from "igniteui-webcomponents-inputs";
import { INativeUIToolPanelBridge } from "./INativeUIToolPanelBridge";
import { Size } from "igniteui-webcomponents-core";
import { NativeUIBuiltInEvents } from "igniteui-webcomponents-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { NativeUIBuiltInProperties } from "igniteui-webcomponents-core";
import { ToolPanelOrientation } from "./ToolPanelOrientation";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { ToolbarOrientation } from "./ToolbarOrientation";
import { ListPanel } from "./ListPanel";
import { List$1 } from "igniteui-webcomponents-core";
import { Popup } from "igniteui-webcomponents-core";
import { NativeUIContent } from "igniteui-webcomponents-core";
import { Rect } from "igniteui-webcomponents-core";
import { Brush } from "igniteui-webcomponents-core";
import { NativeUIContentRefreshedEventArgs } from "./NativeUIContentRefreshedEventArgs";
import { IExecutionContext } from "igniteui-webcomponents-core";
import { BrushCollection } from "igniteui-webcomponents-core";
import { Visibility } from "igniteui-webcomponents-core";
import { ToolActionType } from "igniteui-webcomponents-core";
import { NativeUIGrid } from "igniteui-webcomponents-core";
import { ObservableCollection$1 } from "igniteui-webcomponents-core";
import { ToolActionEventDetail } from "./ToolActionEventDetail";
import { ToolCommandArgument } from "igniteui-webcomponents-core";
import { NativeUIIcon } from "igniteui-webcomponents-core";
import { ListPanelTemplateItemUpdatingEventArgs } from "./ListPanelTemplateItemUpdatingEventArgs";
import { ToolActionMeasurementContext } from "./ToolActionMeasurementContext";
import { ToolActionPerformedEventArgs } from "./ToolActionPerformedEventArgs";
import { ToolCommand } from "igniteui-webcomponents-core";
import { ToolActionInfo } from "igniteui-webcomponents-core";
import { NativeUIButton } from "igniteui-webcomponents-core";
import { NativeUIButtonClickedEventArgs } from "igniteui-webcomponents-core";
import { NativeUIClickedEventArgs } from "igniteui-webcomponents-core";
import { ToolActionButtonDisplayType } from "./ToolActionButtonDisplayType";
import { NativeUIPopup } from "igniteui-webcomponents-core";
import { NativeUIMouseEventArgs } from "igniteui-webcomponents-core";
import { NativeUIFocusEventArgs } from "igniteui-webcomponents-core";
import { ICommandStateChangedListener } from "igniteui-webcomponents-core";
import { IToolbarTarget } from "igniteui-webcomponents-core";
import { ToolCommandStateType } from "igniteui-webcomponents-core";
import { NestedActionMode } from "./NestedActionMode";
import { ToolPanelContentRefreshedEventArgs } from "./ToolPanelContentRefreshedEventArgs";
import { NativeUIAbsolutePanel } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class NativeUILayoutFactory extends Base implements INativeUIElementFactory {
    static $t: Type;
    private static a;
    static get b(): NativeUILayoutFactory;
    static e(): void;
    private c;
    get flavor(): NativeUIElementFactoryFlavor;
    createComponent(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    createComponentSync(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    supportsComponent(a: NativeUIComponentBuiltInType): boolean;
    private d;
}
/**
 * @hidden
 */
export declare class XToolPanelBridge extends XComponentBridge implements INativeUIToolPanelBridge {
    static $t: Type;
    private u;
    private x;
    private v;
    private y;
    private w;
    private z;
    constructor(a: any);
    getDesiredSize(a: any, b: Size): Size;
    addHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    removeHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    private ab;
    private ac;
    private aa;
    setValue(a: any, b: NativeUIBuiltInProperties, c: any): void;
    getValue(a: any, b: NativeUIBuiltInProperties): any;
    refresh(a: any): void;
    notifySizeChanged(a: any, b: Size): void;
}
/**
 * @hidden
 */
export declare class ToolbarView extends Base {
    static $t: Type;
    private o;
    private n;
    private g;
    constructor();
    q(): any;
    a: Toolbar;
    w(): void;
    j: DomRenderer;
    m: DomWrapper;
    e: RenderingContext;
    l: DomWrapper;
    u(a: DomRenderer): void;
    z(): void;
    y(): void;
    t(): void;
    aa(): void;
    private b;
    private ab;
    private c;
    private _gridExternal;
    d(): FontInfo;
    v(): void;
    x(): void;
    s(): void;
    h(): number;
    i(a: string): number;
    f: boolean;
    private k;
    r(a: any, b: (arg1: any) => void): void;
}
/**
 * @hidden
 */
export declare class ToolPanelView extends Base {
    static $t: Type;
    private s;
    private r;
    constructor();
    v(): any;
    c: ToolPanel;
    ac(): void;
    n: DomRenderer;
    get t(): DomWrapper;
    q: DomWrapper;
    g: RenderingContext;
    p: DomWrapper;
    aa(a: DomRenderer): void;
    af(): void;
    y(): void;
    k(): number;
    j(): number;
    ag(): void;
    private d;
    private ai;
    private e;
    private _gridExternal;
    f(): FontInfo;
    ab(): void;
    ae(): void;
    ad(): void;
    z(): void;
    x(): void;
    i(): number;
    l(a: string): number;
    m(a: string, b: FontInfo): number;
    h: boolean;
    private o;
    w(a: any, b: (arg1: any) => void): void;
    a(): Popup;
    b(a: NativeUIContent): ToolPanel;
    ah(a: any): Rect;
}
/**
 * @hidden
 */
export declare class NativeUIToolPanel extends NativeUIComponent {
    static $t: Type;
    private get bk();
    get bp(): ToolActionCollection;
    set bp(a: ToolActionCollection);
    get bt(): number;
    set bt(a: number);
    get bs(): number;
    get bq(): ToolPanelOrientation;
    set bq(a: ToolPanelOrientation);
    get b2(): Brush;
    set b2(a: Brush);
    get bx(): Brush;
    set bx(a: Brush);
    get bw(): Brush;
    set bw(a: Brush);
    get b1(): Brush;
    set b1(a: Brush);
    get by(): Brush;
    set by(a: Brush);
    get bz(): Brush;
    set bz(a: Brush);
    get b0(): Brush;
    set b0(a: Brush);
    get br(): FontInfo;
    set br(a: FontInfo);
    private bl;
    get bm(): (sender: any, args: NativeUIContentRefreshedEventArgs) => void;
    set bm(a: (sender: any, args: NativeUIContentRefreshedEventArgs) => void);
    private bg;
    get bi(): (sender: any, e: DrillDownRequestedEventArgs) => void;
    set bi(a: (sender: any, e: DrillDownRequestedEventArgs) => void);
    private bh;
    get bj(): (sender: any, e: DrillDownRequestedEventArgs) => void;
    set bj(a: (sender: any, e: DrillDownRequestedEventArgs) => void);
    private bn;
    get bo(): (sender: any, args: ToolCommandEventArgs) => void;
    set bo(a: (sender: any, args: ToolCommandEventArgs) => void);
    bv(): void;
    bu(a: Size): void;
}
/**
 * @hidden
 */
export declare abstract class ToolAction extends Base implements INotifyPropertyChanged {
    static $t: Type;
    n: ToolPanel;
    e5(a: ToolPanel): void;
    private e;
    get f(): IExecutionContext;
    set f(a: IExecutionContext);
    get dk(): string;
    h: ToolAction;
    private i;
    get actions(): ToolActionCollection;
    private bd;
    get b0(): number;
    set b0(a: number);
    constructor();
    d8(): void;
    private em;
    private en;
    private ep;
    protected d7(a: ToolAction, b: string): void;
    private dz;
    k(a: boolean): ToolActionEventDetail;
    private ek;
    protected el(a: List$1<ToolCommandArgument>): void;
    dx(): string;
    b3(): any;
    b4(): any;
    private ca;
    get dv(): string;
    set dv(a: string);
    cu: string;
    cr: string;
    dq: string;
    dy(): string;
    private b6;
    get cz(): string;
    set cz(a: string);
    private b5;
    get cw(): string;
    set cw(a: string);
    private b1;
    get b2(): any;
    set b2(a: any);
    private o;
    get p(): BaseControlTheme;
    set p(a: BaseControlTheme);
    private a9;
    get bw(): number;
    set bw(a: number);
    private ay;
    get bh(): number;
    set bh(a: number);
    private ba;
    get bx(): number;
    set bx(a: number);
    private az;
    get bi(): number;
    set bi(a: number);
    private a8;
    get bv(): number;
    set bv(a: number);
    private ax;
    get bg(): number;
    set bg(a: number);
    private bb;
    get by(): number;
    set by(a: number);
    private a0;
    get bj(): number;
    set bj(a: number);
    private fe;
    get ft(): Brush;
    set ft(a: Brush);
    private fm;
    get f0(): Brush;
    set f0(a: Brush);
    private fj;
    private fb;
    get fq(): Brush;
    set fq(a: Brush);
    private fi;
    get fx(): Brush;
    set fx(a: Brush);
    private fh;
    get fw(): Brush;
    set fw(a: Brush);
    private fp;
    get f3(): Brush;
    set f3(a: Brush);
    private fc;
    get fr(): Brush;
    set fr(a: Brush);
    private fk;
    get fy(): Brush;
    set fy(a: Brush);
    private r;
    get u(): FontInfo;
    set u(a: FontInfo);
    private t;
    get w(): FontInfo;
    set w(a: FontInfo);
    private af;
    get an(): boolean;
    set an(a: boolean);
    private ag;
    get ao(): boolean;
    set ao(a: boolean);
    get am(): boolean;
    private b9;
    get dn(): string;
    set dn(a: string);
    private cc;
    get d4(): string;
    set d4(a: string);
    private cb;
    get d0(): string;
    set d0(a: string);
    private bc;
    protected get_bz(): number;
    get bz(): number;
    private b8;
    get db(): string;
    set db(a: string);
    private b7;
    get c7(): string;
    set c7(a: string);
    private a5;
    get bs(): number;
    set bs(a: number);
    private a6;
    get bt(): number;
    set bt(a: number);
    private a7;
    get bu(): number;
    set bu(a: number);
    private a4;
    get br(): number;
    set br(a: number);
    private fn;
    get f1(): Brush;
    set f1(a: Brush);
    private ff;
    get fu(): Brush;
    set fu(a: Brush);
    private a;
    get c(): BrushCollection;
    set c(a: BrushCollection);
    private fo;
    get f2(): Brush;
    set f2(a: Brush);
    private fg;
    get fv(): Brush;
    set fv(a: Brush);
    private b;
    get d(): BrushCollection;
    set d(a: BrushCollection);
    private a3;
    get bq(): number;
    set bq(a: number);
    private f4;
    get f5(): Visibility;
    set f5(a: Visibility);
    private ae;
    get ai(): boolean;
    set ai(a: boolean);
    private a2;
    get bp(): number;
    set bp(a: number);
    private aw;
    get bf(): number;
    set bf(a: number);
    private a1;
    get bo(): number;
    set bo(a: number);
    private av;
    get be(): number;
    set be(a: number);
    private fl;
    get fz(): Brush;
    set fz(a: Brush);
    private fd;
    get fs(): Brush;
    set fs(a: Brush);
    protected get_aj(): boolean;
    protected get aj(): boolean;
    protected get_ak(): boolean;
    protected get ak(): boolean;
    protected get_aq(): boolean;
    protected get aq(): boolean;
    protected get_as(): boolean;
    protected get as(): boolean;
    protected get_ah(): boolean;
    protected get ah(): boolean;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected eq(): void;
    protected ev(a: string, b: any, c: any): void;
    protected get_q(): ToolActionType;
    get q(): ToolActionType;
    protected e2(a: string, b: any, c: any): void;
    private e7;
    private s;
    protected ap(): boolean;
    e9(): void;
    protected fa(): void;
    protected eu(): void;
    ex(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    ey(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    ed(a: ToolPanel, b: ToolActionMeasurementContext): void;
    ee(a: ToolPanel, b: ToolActionMeasurementContext): void;
    bm(a: ToolPanel, b: ToolActionMeasurementContext): number;
    bn(a: ToolPanel, b: ToolActionMeasurementContext): number;
    bl(a: ToolPanel, b: ToolActionMeasurementContext): number;
    v(a: ToolPanel): FontInfo;
    bk(a: ToolPanel, b: ToolActionMeasurementContext): number;
    ew(a: ToolActionEventDetail, b: ToolAction): void;
    private e3;
    protected e4(a: ToolCommand): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    protected at(): boolean;
    private eb;
    al(): boolean;
    private er;
    private ec;
    performed: (sender: any, args: ToolActionPerformedEventArgs) => void;
    static g(a: ToolActionInfo): ToolAction;
    ej(a: ToolActionInfo): void;
    protected ar(): boolean;
    protected au(): boolean;
    protected y(a: NativeUIComponentBuiltInType): NativeUIElementFactoryFlavor;
    private aa;
    protected get ab(): NativeUIGrid;
    private z;
    private x;
    private ac;
    private ad;
    private ei;
    protected eh(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    protected eg(a: NativeUIGrid, b: ToolActionMeasurementContext): void;
    protected e8(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    private ef;
    private eo;
    private e6;
    protected d9(a: NativeUIContent): void;
    protected et(): void;
    protected es(a: any, b: NativeUIClickedEventArgs): void;
    e0(): void;
    ea(): void;
    e1(a: ToolAction): void;
}
/**
 * @hidden
 */
export declare class ToolActionSubPanel extends ToolAction {
    static $t: Type;
    private f6;
    private f7;
    constructor();
    protected get_q(): ToolActionType;
    ee(a: ToolPanel, b: ToolActionMeasurementContext): void;
    protected eh(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    private f9;
    private f8;
    protected d9(a: NativeUIContent): void;
    protected e2(a: string, b: any, c: any): void;
    ej(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionButton extends ToolAction {
    static $t: Type;
    protected get_q(): ToolActionType;
    protected get_bz(): number;
    private f6;
    get f7(): ToolActionButtonDisplayType;
    set f7(a: ToolActionButtonDisplayType);
    private gb;
    get gc(): number;
    set gc(a: number);
    private f9;
    k(a: boolean): ToolActionEventDetail;
    private f8;
    bl(a: ToolPanel, b: ToolActionMeasurementContext): number;
    bn(a: ToolPanel, b: ToolActionMeasurementContext): number;
    bm(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected eh(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    private gg;
    private gf;
    private ga;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected e2(a: string, b: any, c: any): void;
    protected fa(): void;
}
/**
 * @hidden
 */
export declare class ToolActionLabel extends ToolAction {
    static $t: Type;
    private static readonly f7;
    private f6;
    protected get_aj(): boolean;
    constructor();
    protected get_q(): ToolActionType;
    bm(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private f8;
    protected et(): void;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected e2(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class ToolActionRadio extends ToolAction {
    static $t: Type;
    private f6;
    protected get_q(): ToolActionType;
    private gb;
    get gc(): string;
    set gc(a: string);
    private f7;
    get f9(): boolean;
    set f9(a: boolean);
    private f8;
    get ga(): boolean;
    set ga(a: boolean);
    k(a: boolean): ToolActionEventDetail;
    protected el(a: List$1<ToolCommandArgument>): void;
    gf(): void;
    bm(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected fa(): void;
    protected et(): void;
    private gg;
    private gh;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected e2(a: string, b: any, c: any): void;
    ej(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionSeparator extends ToolAction {
    static $t: Type;
    private f8;
    get f9(): number;
    set f9(a: number);
    private f6;
    get f7(): boolean;
    set f7(a: boolean);
    constructor();
    protected get_q(): ToolActionType;
    ee(a: ToolPanel, b: ToolActionMeasurementContext): void;
    protected eh(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    protected eg(a: NativeUIGrid, b: ToolActionMeasurementContext): void;
    protected e8(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected fa(): void;
    protected e2(a: string, b: any, c: any): void;
    ej(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionIconButton extends ToolAction {
    static $t: Type;
    private ga;
    private f7;
    private f6;
    private gl;
    private gm;
    private gg;
    private gd;
    private gc;
    protected get_q(): ToolActionType;
    protected get_as(): boolean;
    protected get gb(): NativeUIPopup;
    protected get_gk(): boolean;
    protected get gk(): boolean;
    private gf;
    protected get gj(): boolean;
    protected set gj(a: boolean);
    private gn;
    get go(): number;
    set go(a: number);
    private gh;
    constructor();
    d8(): void;
    k(a: boolean): ToolActionEventDetail;
    protected f8: NativeUIButton;
    protected f9: NativeUIIcon;
    bl(a: ToolPanel, b: ToolActionMeasurementContext): number;
    bn(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected eh(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    protected d9(a: NativeUIContent): void;
    private g6;
    protected g7(a: NativeUIGrid, b: NativeUIPopup): void;
    protected gq(): void;
    protected gs(): void;
    protected gr(): void;
    protected gt(): void;
    protected g8(): Size;
    private g4;
    private gi;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected fa(): void;
    protected eu(): void;
    e0(): void;
    ea(): void;
    protected g5(a?: boolean): void;
    protected gp(): void;
    private gz;
    private gu;
    protected gx(a: any, b: NativeUIMouseEventArgs): void;
    protected gy(a: any, b: NativeUIMouseEventArgs): void;
    protected gv(a: any, b: NativeUIButtonClickedEventArgs): void;
    private ge;
    private g2;
    private g3;
    private g0;
    private g1;
    protected gw(a: any, b: NativeUIFocusEventArgs): void;
    protected e2(a: string, b: any, c: any): void;
    ej(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionGroupHeader extends ToolAction {
    static $t: Type;
    private static readonly f9;
    private f6;
    private f7;
    protected get_q(): ToolActionType;
    protected get_aj(): boolean;
    protected get_ak(): boolean;
    protected get_aq(): boolean;
    private gd;
    get gf(): Brush;
    set gf(a: Brush);
    private ge;
    get gg(): Brush;
    set gg(a: Brush);
    constructor();
    v(a: ToolPanel): FontInfo;
    bk(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private gc;
    private gb;
    protected d9(a: NativeUIContent): void;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected fa(): void;
}
/**
 * @hidden
 */
export declare class ToolActionIconMenu extends ToolActionIconButton {
    static $t: Type;
    private g9;
    private hb;
    protected ha: NativeUIIcon;
    protected get_q(): ToolActionType;
    private hm;
    get hp(): Brush;
    set hp(a: Brush);
    private hn;
    private hl;
    get ho(): Brush;
    set ho(a: Brush);
    private hc;
    get he(): boolean;
    set he(a: boolean);
    protected get_gk(): boolean;
    protected gq(): void;
    protected eq(): void;
    protected gs(): void;
    protected gr(): void;
    protected gt(): void;
    protected fa(): void;
    protected g8(): Size;
    protected g5(a?: boolean): void;
    private hk;
    private hd;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    private hi;
    protected e2(a: string, b: any, c: any): void;
    private hj;
    protected d7(a: ToolAction, b: string): void;
    e1(a: ToolAction): void;
}
/**
 * @hidden
 */
export declare class ToolActionCheckbox extends ToolAction {
    static $t: Type;
    private f6;
    protected get_q(): ToolActionType;
    protected get_ah(): boolean;
    private f7;
    get f8(): boolean;
    set f8(a: boolean);
    k(a: boolean): ToolActionEventDetail;
    protected el(a: List$1<ToolCommandArgument>): void;
    bm(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected d9(a: NativeUIContent): void;
    protected et(): void;
    private gb;
    private ga;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected fa(): void;
    protected e2(a: string, b: any, c: any): void;
    ej(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionNumberInput extends ToolAction {
    static $t: Type;
    private f6;
    protected get_q(): ToolActionType;
    private f7;
    get f9(): number;
    set f9(a: number);
    protected el(a: List$1<ToolCommandArgument>): void;
    bm(a: ToolPanel, b: ToolActionMeasurementContext): number;
    f8(): number;
    k(a: boolean): ToolActionEventDetail;
    private gb;
    private gc;
    ez(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected fa(): void;
    protected e2(a: string, b: any, c: any): void;
    protected et(): void;
    ej(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionCollection extends ObservableCollection$1<ToolAction> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class Toolbar extends Base implements INotifyPropertyChanged, ICommandStateChangedListener {
    static $t: Type;
    m: ToolbarView;
    private y;
    constructor();
    private w;
    private get x();
    private p;
    ck(a: ToolPanel): void;
    private cb;
    private n;
    private cr;
    private cp;
    cn(a: Size): void;
    private q;
    get r(): BaseControlTheme;
    set r(a: BaseControlTheme);
    private f;
    get autoGeneratedActions(): ToolActionCollection;
    set autoGeneratedActions(a: ToolActionCollection);
    private d;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    private e;
    get actualActions(): ToolActionCollection;
    set actualActions(a: ToolActionCollection);
    static k: ToolbarOrientation;
    private j;
    get l(): ToolbarOrientation;
    set l(a: ToolbarOrientation);
    s: IToolbarTarget;
    static a8: any;
    private a7;
    get target(): any;
    set target(a: any);
    private c1;
    get de(): Brush;
    set de(a: Brush);
    private da;
    get dn(): Brush;
    set dn(a: Brush);
    private c3;
    get dg(): Brush;
    set dg(a: Brush);
    private c9;
    get dm(): Brush;
    set dm(a: Brush);
    private c6;
    get dj(): Brush;
    set dj(a: Brush);
    db: Brush;
    get dp(): Brush;
    set dp(a: Brush);
    c2: Brush;
    get df(): Brush;
    set df(a: Brush);
    private c4;
    get dh(): Brush;
    set dh(a: Brush);
    private dd;
    get dr(): Brush;
    set dr(a: Brush);
    private dc;
    get dq(): Brush;
    set dq(a: Brush);
    private ar;
    get a3(): number;
    set a3(a: number);
    private as;
    get a4(): number;
    set a4(a: number);
    private c7;
    get dk(): Brush;
    set dk(a: Brush);
    private c8;
    get dl(): Brush;
    set dl(a: Brush);
    private t;
    get u(): FontInfo;
    set u(a: FontInfo);
    v(): FontInfo;
    private ao;
    get a0(): number;
    set a0(a: number);
    private ap;
    get a1(): number;
    set a1(a: number);
    private aq;
    get a2(): number;
    set a2(a: number);
    private an;
    get az(): number;
    set az(a: number);
    private ak;
    get aw(): number;
    set aw(a: number);
    private al;
    get ax(): number;
    set ax(a: number);
    private am;
    get ay(): number;
    set ay(a: number);
    private aj;
    get av(): number;
    set av(a: number);
    private ab;
    get ae(): boolean;
    set ae(a: boolean);
    private ai;
    get au(): number;
    set au(a: number);
    private ah;
    get at(): number;
    set at(a: number);
    private c5;
    get di(): Brush;
    set di(a: Brush);
    private a5;
    get a6(): number;
    set a6(a: number);
    private _userSetWidth;
    get userSetWidth(): boolean;
    set userSetWidth(a: boolean);
    private _userSetHeight;
    get userSetHeight(): boolean;
    set userSetHeight(a: boolean);
    private cc;
    private ce;
    private cf;
    private c0;
    private cd;
    private cm;
    private aa;
    private z;
    protected cu(): void;
    private ci;
    private cv;
    private ac;
    private ad;
    private cj;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected co(a: string, b: any, c: any): void;
    protected cs(a: string, b: any, c: any): void;
    private cz;
    ds(): Size;
    private cq;
    private b;
    get c(): IExecutionContext;
    set c(a: IExecutionContext);
    cg(): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    onCommandStateChanged(a: string, b: ToolCommandStateType, c: any): void;
    private cw;
    cx(a: string, b: string, c: string): void;
    bj(a: string, b: string): string;
    cy(a: string, b: string, c: string[]): void;
    a(a: string, b: string): string[];
}
/**
 * @hidden
 */
export declare class ToolPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    p: ToolPanelView;
    x: NativeUIGrid;
    by: any;
    private aa;
    private y;
    private get z();
    d1(a: ListPanel): void;
    private dn;
    private dp;
    private dq;
    private i;
    private dr;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private g;
    d6(a: Size): void;
    contentRefreshed: (sender: any, args: ToolPanelContentRefreshedEventArgs) => void;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    private ac;
    get ae(): boolean;
    set ae(a: boolean);
    constructor();
    private ds;
    private dt;
    private d5;
    private ab;
    protected ed(): void;
    ef(): void;
    private dy;
    private ag;
    private ah;
    private af;
    private du;
    ad(a: ToolAction): boolean;
    f(a: string): ToolAction;
    ai(a: ToolAction): List$1<ToolAction>;
    private j;
    private d9;
    private d3;
    private ej;
    f7(): Size;
    private dz;
    d0(): void;
    eg(): void;
    ee(a: ToolAction): void;
    private d2;
    private dv;
    ea(): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private t;
    get v(): FontInfo;
    set v(a: FontInfo);
    private s;
    get u(): FontInfo;
    set u(a: FontInfo);
    w(): FontInfo;
    protected d7(a: string, b: any, c: any): void;
    protected eb(a: string, b: any, c: any): void;
    private em;
    private el;
    private ek;
    a: IExecutionContext;
    private q;
    get r(): BaseControlTheme;
    set r(a: BaseControlTheme);
    private e1;
    get ft(): Brush;
    set ft(a: Brush);
    private en;
    get ff(): Brush;
    set ff(a: Brush);
    private fb;
    get f3(): Brush;
    set f3(a: Brush);
    private ex;
    get fp(): Brush;
    set fp(a: Brush);
    private e3;
    get fv(): Brush;
    set fv(a: Brush);
    private ep;
    get fh(): Brush;
    set fh(a: Brush);
    private fa;
    get f2(): Brush;
    set f2(a: Brush);
    private ew;
    get fo(): Brush;
    set fo(a: Brush);
    private e4;
    get fw(): Brush;
    set fw(a: Brush);
    static readonly b4: string;
    private eq;
    get fi(): Brush;
    set fi(a: Brush);
    private e7;
    get fz(): Brush;
    set fz(a: Brush);
    private et;
    get fl(): Brush;
    set fl(a: Brush);
    private d;
    private ax;
    fc: Brush;
    get f4(): Brush;
    set f4(a: Brush);
    private ey;
    get fq(): Brush;
    set fq(a: Brush);
    e2: Brush;
    get fu(): Brush;
    set fu(a: Brush);
    private eo;
    get fg(): Brush;
    set fg(a: Brush);
    private e5;
    get fx(): Brush;
    set fx(a: Brush);
    private er;
    get fj(): Brush;
    set fj(a: Brush);
    private fe;
    get f6(): Brush;
    set f6(a: Brush);
    private e0;
    get fs(): Brush;
    set fs(a: Brush);
    private fd;
    get f5(): Brush;
    set f5(a: Brush);
    private ez;
    get fr(): Brush;
    set fr(a: Brush);
    private a6;
    get bv(): number;
    set bv(a: number);
    private at;
    get bj(): number;
    set bj(a: number);
    private a7;
    get bw(): number;
    set bw(a: number);
    private au;
    get bk(): number;
    set bk(a: number);
    private e8;
    get f0(): Brush;
    set f0(a: Brush);
    private eu;
    get fm(): Brush;
    set fm(a: Brush);
    private e9;
    get f1(): Brush;
    set f1(a: Brush);
    private ev;
    get fn(): Brush;
    set fn(a: Brush);
    private a3;
    get bs(): number;
    set bs(a: number);
    private aq;
    get bg(): number;
    set bg(a: number);
    private a4;
    get bt(): number;
    set bt(a: number);
    private ar;
    get bh(): number;
    set bh(a: number);
    private a5;
    get bu(): number;
    set bu(a: number);
    private as;
    get bi(): number;
    set bi(a: number);
    private a2;
    get br(): number;
    set br(a: number);
    private ap;
    get bf(): number;
    set bf(a: number);
    private az;
    get bo(): number;
    set bo(a: number);
    private am;
    get bc(): number;
    set bc(a: number);
    private a0;
    get bp(): number;
    set bp(a: number);
    private an;
    get bd(): number;
    set bd(a: number);
    private a1;
    get bq(): number;
    set bq(a: number);
    private ao;
    get be(): number;
    set be(a: number);
    private ay;
    get bn(): number;
    set bn(a: number);
    private al;
    get bb(): number;
    set bb(a: number);
    static n: ToolPanelOrientation;
    private m;
    get o(): ToolPanelOrientation;
    set o(a: ToolPanelOrientation);
    d8(a: ToolAction, b: ToolCommandEventArgs): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    get bx(): number;
    set bx(a: number);
    get ba(): number;
    private aw;
    get bm(): number;
    set bm(a: number);
    private ak;
    get a9(): number;
    set a9(a: number);
    private av;
    get bl(): number;
    set bl(a: number);
    private aj;
    get a8(): number;
    set a8(a: number);
    private e6;
    get fy(): Brush;
    set fy(a: Brush);
    private es;
    get fk(): Brush;
    set fk(a: Brush);
    e: NestedActionMode;
    drillDownRequested: (sender: any, e: DrillDownRequestedEventArgs) => void;
    drillUpRequested: (sender: any, e: DrillDownRequestedEventArgs) => void;
    eh(a: ToolAction): void;
    ei(a: ToolAction): void;
    dw(): void;
}
/**
 * @hidden
 */
export declare class DrillDownRequestedEventArgs extends Base {
    static $t: Type;
    a: ToolAction;
}
/**
 * @hidden
 */
export declare class ToolPanelsPresenter extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private ab;
    private i;
    private j;
    private y;
    private o;
    private a;
    private d;
    private g;
    private ay;
    private az;
    private p;
    private b;
    private e;
    private h;
    private c;
    private f;
    private w;
    private get a0();
    private set a0(value);
    private get a1();
    private set a1(value);
    r: NativeUIGrid;
    q: NativeUIAbsolutePanel;
    private u;
    get v(): List$1<PanelInfo>;
    private m;
    get n(): BaseControlTheme;
    set n(a: BaseControlTheme);
    private x;
    get z(): number;
    set z(a: number);
    s: (arg1: ToolCommandEventArgs) => void;
    private aa;
    constructor(a: any, b: IExecutionContext);
    ai(a: () => void): void;
    a2(): Size;
    ae(a: ToolAction, b?: (arg1: NativeUIToolPanel) => void): void;
    aj(a: NativeUIToolPanel): void;
    al(a: number): void;
    ak(a: PanelInfo, b?: () => void): void;
    private aq;
    private ar;
    private ao;
    private af;
    private ah;
    private an;
    private t;
    av(): void;
    private ag;
    aw(): void;
    ax(a: BaseControlTheme, b: ToolPanel): void;
    am(): void;
    containerReady: (sender: any) => void;
    private ap;
    sizeChanged: (sender: any) => void;
    private at;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private as;
    protected au(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class PanelInfo extends Base {
    static $t: Type;
    c: number;
    a: NativeUIToolPanel;
    b: ToolAction;
    constructor(a: ToolAction, b: NativeUIToolPanel, c: number);
    f(): Size;
    e(): void;
    d(a: Size): void;
}
/**
 * @hidden
 */
export declare class PanelAnimationRequest extends Base {
    static $t: Type;
    a: PanelInfo;
    c: number;
    b: () => void;
}
